// ============================ Atmega128 CPU ׽Ʈ α׷ =================
//  CPU : ATmega128-16M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#include <mega128.h>						// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <math.h>

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// WATCH-DOG 
#define wdt_reset() #asm("wdr")

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x33;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/1024k = 1.01
	WDTCR=0x1e;
	WDTCR=0x0e;
	wdt_reset();

// Global enable interrupts
#asm("sei")
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [USART0_RXC] void uart0_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR0A;
	data=UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// Լ 
void main_menu_disp(void);					//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	wdt_reset();						// watch-dog reset
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') while(1);
			putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
		wdt_reset();					// watch-dog reset
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("=================== WATCH-DOG TEST ==================\r\n");
	printf("- 1 : WATCH-DOG RESET                               -\r\n");
	printf("-----------------------------------------------------\r\n");
}
